#!/bin/sh

# This script showcases the usage of the TRONTEQ ROQSTAR openAPI.
# It is compatible with ROQSTAR openAPI v1.0.
# Version of this script: 1.0.
# 
# Contact:
# www.tronteq.com
# support@tronteq.com



login()
{
	curl -X 'POST' \
	"$1/oapi/v1/login" \
	-H 'accept: */*' \
	-H 'Content-Type: application/json' \
	-d '{"user":"admin", "password":"password"}' \
	-c cookies.jar
}

get_link_status()
{
	curl -X 'GET' \
	"$1/oapi/v1/status/link/status" \
	-H 'accept: application/json' \
	-b cookies.jar
}

get_running_configuration()
{
	curl -X 'GET' \
	"$1/oapi/v1/configuration/running" \
	-H 'accept: application/json' \
	-b cookies.jar
}

upload_and_apply_configuration_persistently()
{
	encoded=`base64 -w 0 $2`
	curl -X 'PUT' \
	"$1/oapi/v1/configuration/startup" \
	-H 'accept: application/json' \
	-H 'Content-Type: application/json' \
	-d '{"name": "'$2'", "content": "'$encoded'"}' \
	-b cookies.jar
}

get_configuration_status()
{
	curl -X 'GET' \
	"$1/oapi/v1/openapi/status/configuration" \
	-H 'accept: application/json' \
	-b cookies.jar
}

install_software()
{
	curl -X 'PUT' \
	"$1/oapi/v1/system/software" \
	-H 'accept: */*' \
	-H 'Content-Type: application/octet-stream' \
	-b cookies.jar \
	--data-binary "@$2"
}

reboot()
{
	curl -X 'POST' \
	"$1/oapi/v1/system/reboot" \
	-H 'accept: */*' \
	-d '' \
	-b cookies.jar
}



ip="192.168.1.1"
login $ip
get_link_status $ip
get_running_configuration $ip
upload_and_apply_configuration_persistently $ip "test.cfg"
sleep 10
get_configuration_status $ip
install_software $ip "update.raucb"
reboot $ip
